﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////

var DisplayKW;

function Init()
{
	headimg.src = "/img/Flyout/calhead.png";
	content.style.backgroundColor = System.Gadget.Settings.read("gadgetcolourback");
	content.style.color = System.Gadget.Settings.read("gadgetcolourlabel");
	loadSettings();
}

function loadSettings()
{
	kwtext.innerText = SettText[33];
	DisplayKW=System.Gadget.Settings.read("kwselect");
	fillKWcombo();
	kwselect.value = DisplayKW;

}

function fillKWcombo()
{
	kwselect.options[0] = new Option(SettText[34], "0"); // ISO
	kwselect.options[1] = new Option(SettText[35], "1"); // USA
	kwselect.options[2] = new Option(SettText[39], "2"); // JUL
	kwselect.options[3] = new Option(SettText[40], "3"); // ISL
}

function onchangeaction(wert)
{
	if (wert == "kwselect")
	{
		if (kwselect.value == 0) // ISO
		{
			System.Gadget.Settings.write("firstwdayselect",1);
		}
		else if (kwselect.value == 3) // Islamic
		{
			System.Gadget.Settings.write("firstwdayselect",0);
		}

		System.Gadget.Settings.write("kwselect", kwselect.value);
		System.Gadget.Settings.write("lastCalendar", "");
		System.Gadget.Settings.write("calflyoutclosed", 1);
		System.Gadget.Flyout.show = false;
	}
}


