﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////

var wireless = System.Network.Wireless;
var status;

var objWMIService = null;
var WMI = GetObject("winmgmts:\\\\.\\root\\CIMV2");
var WMI2 = GetObject("winmgmts:\\\\.\\root\\WMI");
var interfaceCount = System.Gadget.document.parentWindow.interfaceCount;
var currentWInterface = System.Gadget.Settings.read("wintfselect");
var currentInterface = System.Gadget.Settings.read("intfselect");

var wcurrIP;
var wcurrMAC;
var lcurrIP;
var lcurrMAC;
var currDomain;
var WiFiAuthentification = "";
var WiFiEncryption = "";
var wlanintftype = "";
var lanintftype = "";
var lbytesReceived;
var lbytesSent;
var llastbytesReceived;
var llastbytesSent;
var wbytesReceived;
var wbytesSent;
var wlastbytesReceived;
var wlastbytesSent;
var wbandw;
var lbandw;
var lanintf2;
var wlanintf2;
var lanstat;
var lanintf;

var firstrun = "1";

function Init()
{
	netCollect.innerText = SomeText[1];
	netCollect.style.display="block";
	netDetails.style.display="none";

	content.style.backgroundColor = System.Gadget.Settings.read("gadgetcolourback");
	content.style.color = System.Gadget.Settings.read("gadgetcolourlabel");

	setTable();
    onTimer();
    setInterval(onTimer,980);
    firstrun = "0";
}

function onTimer()
{
	if (firstrun == "1")
	{
	    firstrun = "0";
	}
	else
	{
		networkDetails();
	    firstrun = "0";
	}
}

function setTable()
{
	Rximage.src = "/img/Icons/arrow_down.png";
	Tximage.src = "/img/Icons/arrow_up.png";
	lRximage.src = "/img/Icons/arrow_down.png";
	lTximage.src = "/img/Icons/arrow_up.png";
	headimg.src = "/img/Flyout/headimg.png";
	nhead.innerText = WLANText[24];
	nfoot.innerText = SomeText[0];
	networkDetailsStatusTxt.innerText = "Status";
	networkDetailsssidTxt.innerText = "SSID";
	networkDetailsDomainTxt.innerText = WLANText[28];
	networkDetailsSignaldbMTxt.innerText = WLANText[1];
	networkDetailsSignalPercentTxt.innerText = WLANText[2];
	networkDetailsQualityTxt.innerText = WLANText[17];
	networkDetailsAddressTxt.innerText = WLANText[3];
	networkDetailsMACTxt.innerText = WLANText[27];
	networkDetailsSecurityTxt.innerText = WLANText[4];
	networkDetailsBandwidthTxt.innerText = WLANText[9];
	networkDetailsTransferTxt.innerText = WLANText[25];
	networkDetailsInterfaceTxt.innerText = WLANText[26];
	networkDetailsInterfaceTypeTxt.innerText = "CardType";
}

//Checking network details
function networkDetails()
{
	var ssid = wireless.ssid;
//	if (ssid.length>20) ssid=ssid.substr(0,17)+"...";
	var Strength = wireless.signalStrength;
	var ip = wireless.address;
	var primaryDNS = wireless.primaryDNSAddress;
	var security = wireless.secureConnection;
	var dns = wireless.primaryDNSAddress;
	var StrengthdbM;
	var SignalQualitydbM;

	currDomain = getDomain();
//	if (currDomain.length>20) currDomain=currDomain.substr(0,17)+"...";
	var intervalDivisor = 1;

	if (currentInterface == "0")
	{
		lbandw = "--";
		var lRx = "--";
		var lTx = "--";
	}
	else
	{
		lanstat = System.Gadget.document.parentWindow.lstat;
		lanintf = System.Gadget.Settings.read("intfname");
		getIP(lanintf,"l");

		var i = "";
		var i2= "";
		for (i=1; i<System.Gadget.document.parentWindow.InterfaceArray.length; i++)
		{
			var iA1 = System.Gadget.document.parentWindow.InterfaceArray[i];
			if (lanintf == iA1)
			{
				var iA1 = iA1.replace(/\(\S*|\[\S*/g, "");
				iA1 = iA1.replace(/\_|\/|\-|\.|\]|\)/g, "");
				iA1 = iA1.replace(/\s/g, "");
				for (i2=1; i2<System.Gadget.document.parentWindow.InterfaceArray2.length; i2++)
				{
					var iA2 = System.Gadget.document.parentWindow.InterfaceArray2[i2];
					iA2 = iA2.replace(/\(\S*|\[\S*/g, "");
					iA2 = iA2.replace(/\_|\/|\-|\.|\]|\)/g, "");
					iA2 = iA2.replace(/\s/g, "");
					if (iA1 == iA2)
					{
						lanintf2 = System.Gadget.document.parentWindow.InterfaceArray2[i2];
					}
				}
			}
		}

		getPerformanceData(lanintf2, "l");
		if (lbandw) lbandw = parseInt(lbandw/1000000) + " Mbps";
		if (lbytesSent)
		{
			var lsentKB = parseInt(lbytesSent/1024);
			var lreceivedKB = parseInt(lbytesReceived/1024);

			if ( lsentKB > 1024)
			{
				var lTx = (lsentKB / 1024).toString().substring(0,5) + "MB/s";
			}
			else
			{
				var lTx = lsentKB + "KB/s";
			}
			if ( lreceivedKB > 1024)
			{
				var lRx = (lreceivedKB / 1024).toString().substring(0,5) + "MB/s";
			}
			else
			{
				var lRx = lreceivedKB + "KB/s";
			}
		}
		else
		{
			lRx = "0";
			lTx = "0";
		}
	}

	//If connected display, the network information, if there's an SSID then you are connected
	if (ssid != "")
	{
		status = true;

		if (currentWInterface == "0")
		{
			wcurrMAC = "--";
			wlanintf = "--";
			wlanintftype = "--";
			wbandw = "--";
			var wRx = "--";
			var wTx = "--";
		}
		else
		{
			var wlanintf = System.Gadget.Settings.read("wintfname");
			getIP(wlanintf,"w");

			i = "";
			i2= "";
			for (i=1; i<System.Gadget.document.parentWindow.InterfaceArray.length; i++)
			{
				var wiA1 = System.Gadget.document.parentWindow.InterfaceArray[i];
				if (wlanintf == wiA1)
				{
					var wiA1 = wiA1.replace(/\(\S*|\[\S*/g, "");
					wiA1 = wiA1.replace(/\_|\/|\-|\.|\]|\)/g, "");
					wiA1 = wiA1.replace(/\s/g, "");
					for (i2=1; i2<System.Gadget.document.parentWindow.InterfaceArray2.length; i2++)
					{
						var wiA2 = System.Gadget.document.parentWindow.InterfaceArray2[i2];
						wiA2 = wiA2.replace(/\(\S*|\[\S*/g, "");
						wiA2 = wiA2.replace(/\_|\/|\-|\.|\]|\)/g, "");
						wiA2 = wiA2.replace(/\s/g, "");
						if (wiA1 == wiA2)
						{
							wlanintf2 = System.Gadget.document.parentWindow.InterfaceArray2[i2];
						}
					}
				}
			}

//			var wbandw = getInterfaceSpeed(wlanintf, "bw")/1000000 + " Mbps";

			getPerformanceData(wlanintf2, "w");
			if (wbandw) wbandw = parseInt(wbandw/1000000) + " Mbps";
			if (wbytesSent)
			{
				var wsentKB = parseInt(wbytesSent/1024);
				var wreceivedKB = parseInt(wbytesReceived/1024);

				if ( wsentKB > 1024)
				{
					var wTx = (wsentKB / 1024).toString().substring(0,5) + "MB/s";
				}
				else
				{
					var wTx = wsentKB + "KB/s";
				}
				if ( wreceivedKB > 1024)
				{
					var wRx = (wreceivedKB / 1024).toString().substring(0,5) + "MB/s";
				}
				else
				{
					var wRx = wreceivedKB + "KB/s";
				}
			}
			else
			{
				wRx = "0";
				wTx = "0";
			}

			StrengthdbM = getStrengthdbM(wlanintf);
			if (!StrengthdbM)
			{
				StrengthdbM = getStrengthdbM2(wlanintf);
			}
			if (!StrengthdbM)
			{
				StrengthdbM = "--";
				SignalQualitydbM = "";
				wlanintftype = "--";
			}
			else
			{
				SignalQualitydbM = getSignalQualitydbM(wlanintf);
				getWiFiAuthentification(wlanintf);
				wlanintftype = getInterfaceType(wlanintf);
			}
		}

		networkDetailsStatus.innerText = WLANText[6];
		networkDetailsssid.innerText = ssid;

		if (currDomain)
		{
			networkDetailsDomain.innerText = currDomain;
		}
		else
		{
			networkDetailsDomain.innerText = "--";
		}

		if (StrengthdbM)
		{
			networkDetailsSignaldbM.innerText = StrengthdbM + " dbM";
		}
		else
		{
			networkDetailsSignaldbM.innerText = "--" + " dbM";
		}
		networkDetailsSignalPercent.innerText = Strength + "%";
		networkDetailsAddress.innerText = wireless.address;
		networkDetailsMAC.innerText = wcurrMAC;
		if (WiFiAuthentification)
		{
			var nds = WiFiAuthentification;
			if (WiFiEncryption)
			{
				nds += "\n" + WiFiEncryption;
			}
			networkDetailsSecurity.innerText = nds;
		}
		else
		{
			if(security == true)
			{
				networkDetailsSecurity.innerText = WLANText[10];
			}
			else
			{
				networkDetailsSecurity.innerText = WLANText[11];
			}
		}
		networkDetailsDns.innerText = WLANText[5];
		networkDetailsInterface.innerText = wlanintf;

		if (wlanintftype)
		{
			networkDetailsInterfaceType.innerText = wlanintftype;
		}
		else
		{
			networkDetailsInterfaceType.innerText = "--";
		}

		networkDetailsBandwidth.innerText = wbandw;
		networkDetailsTransfer.innerText = wRx + " | " + wTx;
	}
	//If not connected, then display the filler
	else
	{
		status = false;
		networkDetailsStatus.innerText = WLANText[7];
		networkDetailsssid.innerText = "--";
		networkDetailsDomain.innerText = "--";
		networkDetailsSignaldbM.innerText = "--";
		networkDetailsSignalPercent.innerText = "--";
		networkDetailsSecurity.innerText = "--";
		networkDetailsInterface.innerText = "--";
		networkDetailsInterfaceType.innerText = "--";
		networkDetailsBandwidth.innerText = "--";
		networkDetailsAddress.innerText = "--";
		networkDetailsMAC.innerText = "--";
		networkDetailsDns.innerText = WLANText[16];
		networkDetailsTransfer.innerText = "--";
	}

	if (status == true)
	{
		if (SignalQualitydbM)
		{
			networkDetailsQuality.innerText = SignalQualitydbM;
		}
		else
		{
			if (Strength > 79)
			{
				networkDetailsQuality.innerText = WLANText[18];
			}
			else if (Strength > 59)
			{
				networkDetailsQuality.innerText = WLANText[19];
			}
			else if (Strength > 39)
			{
				networkDetailsQuality.innerText = WLANText[20];
			}
			else if (Strength > 19)
			{
				networkDetailsQuality.innerText = WLANText[21];
			}
			else if (Strength > 0)
			{
				networkDetailsQuality.innerText = WLANText[22];
			}
			else
			{
				networkDetailsQuality.innerText = WLANText[23];
			}
		}
	}
	else
	{
		networkDetailsQuality.innerText = "--";
	}

	if (lanstat)
	{
		networkDetailsStatusLAN.innerText = WLANText[6];
		networkDetailsssidLAN.innerText = "--";
		networkDetailsDomainLAN.innerText = currDomain;
		networkDetailsSignaldbMLAN.innerText = "--";
		networkDetailsSignalPercentLAN.innerText = "--";
		networkDetailsQualityLAN.innerText = "--";
		networkDetailsSecurityLAN.innerText = "--";
		networkDetailsInterfaceLAN.innerText = lanintf;
		networkDetailsInterfaceTypeLAN.innerText = "--";
		networkDetailsBandwidthLAN.innerText = lbandw;
		networkDetailsTransferLAN.innerText = lRx + " | " + lTx;
		networkDetailsAddressLAN.innerText = lcurrIP;
		networkDetailsMACLAN.innerText = lcurrMAC;
	}
	else
	{
		networkDetailsStatusLAN.innerText = WLANText[7];
		networkDetailsssidLAN.innerText = "--";
		networkDetailsDomainLAN.innerText = "--";
		networkDetailsSignaldbMLAN.innerText = "--";
		networkDetailsSignalPercentLAN.innerText = "--";
		networkDetailsQualityLAN.innerText = "--";
		networkDetailsSecurityLAN.innerText = "--";
		networkDetailsInterfaceLAN.innerText = "--";
		networkDetailsInterfaceTypeLAN.innerText = "--";
		networkDetailsBandwidthLAN.innerText = lbandw;
		networkDetailsTransferLAN.innerText = lRx + " | " + lTx;
		networkDetailsAddressLAN.innerText = "--";
		networkDetailsMACLAN.innerText = "--";
	}

	netCollect.style.display="none";
	netDetails.style.display="block";
}

function getPerformanceData(intf, type)
{
	var wbemFlagReturnImmediately = 0x10;
	var wbemFlagForwardOnly = 0x20;
	var objWMIService = GetObject("winmgmts:\\\\.\\root\\CIMV2");
	var colItems = objWMIService.ExecQuery("SELECT * FROM Win32_PerfFormattedData_Tcpip_NetworkInterface", "WQL", wbemFlagReturnImmediately | wbemFlagForwardOnly);
	var enumItems = new Enumerator(colItems);
	for (; !enumItems.atEnd(); enumItems.moveNext())
	{
		var objItem = enumItems.item();
		if (objItem.Name == intf)
		{
			if (type == "w")
			{
				wbandw = objItem.CurrentBandwidth;
				wbytesReceived = objItem.BytesReceivedPersec;
				wbytesSent = objItem.BytesSentPersec;
			}
			if (type == "l")
			{
				lbandw = objItem.CurrentBandwidth;
				lbytesReceived = objItem.BytesReceivedPersec;
				lbytesSent = objItem.BytesSentPersec;
			}
		}
	}
}

function getPerformanceRawData(intf, intfservice)
{
	var wbemFlagReturnImmediately = 0x10;
	var wbemFlagForwardOnly = 0x20;
	var objWMIService = GetObject("winmgmts:\\\\.\\root\\CIMV2");
	var colItems = objWMIService.ExecQuery("SELECT * FROM Win32_PerfRawData_Tcpip_NetworkInterface", "WQL", wbemFlagReturnImmediately | wbemFlagForwardOnly);
	var enumItems = new Enumerator(colItems);
	for (; !enumItems.atEnd(); enumItems.moveNext())
	{
		var objItem = enumItems.item();
		if (objItem.Name == intf)
		{
			if (intfservice == "bw")
			{
				return objItem.CurrentBandwidth;
			}
			else if (intfservice == "rx")
			{
				return objItem.BytesReceivedPersec;
			}
			else if (intfservice == "tx")
			{
				return objItem.BytesSentPersec;
			}
		}
	}
}

function getStrengthdbM(wlanintf)
{
	try
	{
		var query="SELECT RSSI FROM WiFi_AdapterSignalParameters WHERE Description=\"";
		query += wlanintf;
		query += "\"";
		var proc = WMI.ExecQuery(query,"WQL",48);
		var enu = new Enumerator(proc);
		return enu.item().RSSI;
	}
	catch(err)
	{
	}
}

function getStrengthdbM2(wlanintf)
{
	try
	{
		var query="SELECT Ndis80211ReceivedSignalStrength FROM MSNdis_80211_ReceivedSignalStrength WHERE InstanceName=\"";
		query += wlanintf;
		query += "\"";
		var oWLAN = WMI2.ExecQuery(query,"WQL",48);
		var enumInstances = new Enumerator(oWLAN);
		for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
		{
			var oDevice = enumInstances.item();
			var enumProps = new Enumerator(oDevice.Properties_);
			for (; !enumProps.atEnd(); enumProps.moveNext() )
			{
				var prop = enumProps.item();
				if (prop.Name == "Ndis80211ReceivedSignalStrength")
				{
					return prop.Value;
				}
			}
		}
	}
	catch (err)
	{
	}
}

function getSignalQualitydbM(wlanintf)
{
	var query="SELECT SignalQuality FROM WiFi_AdapterSignalParameters WHERE Description=\"";
	query += wlanintf;
	query += "\"";
	var proc = WMI.ExecQuery(query,"WQL",48);
	var enu = new Enumerator(proc);
	return enu.item().SignalQuality;
}

function getInterfaceType(wlanintf)
{
	var query="SELECT CardType FROM WiFi_AdapterDevice WHERE Description=\"";
	query += wlanintf;
	query += "\"";
	var proc = WMI.ExecQuery(query,"WQL",48);
	if (proc)
	{
		var enu = new Enumerator(proc);
		return enu.item().CardType;
	}
	else
	{
		return "0";
	}
}

function getInterfaceSpeed(wlanintf)
{
	var query="SELECT Speed FROM WiFi_NetworkAdapter WHERE Description=\"";
	query += wlanintf;
	query += "\"";
	var proc = WMI.ExecQuery(query,"WQL",48);
	if (proc)
	{
		var enu = new Enumerator(proc);
		return enu.item().Speed;
	}
	else
	{
		return "0";
	}
}

function getWiFiAuthentification(wlanintf)
{
	var query="SELECT * FROM WiFi_AdapterAssociationInfo WHERE Description=\"";
	query += wlanintf;
	query += "\"";
	proc = WMI.ExecQuery(query,"WQL",48);
	var e = new Enumerator (proc);
	for (;!e.atEnd();e.moveNext ())
	{
		var p = e.item ();
		if (p.AuthenMode != null)
		{
			WiFiAuthentification = p.AuthenMode;
		}
		else
		{
			WiFiAuthentification = "--";
		}
		if (p.Encryption != null)
		{
			WiFiEncryption = p.Encryption;
		}
		else
		{
			WiFiEncryption = "--";
		}
	}
}

function getIP(intf,type)
{
	var proc;
	var query="SELECT * FROM Win32_NetworkAdapterConfiguration WHERE Description=";
	query += "\"";
	query += intf
	query +=  "\"";
	proc = WMI.ExecQuery(query,"WQL",48);
	var e = new Enumerator (proc);
	for (;!e.atEnd();e.moveNext ())
	{
		var p = e.item ();
		if (p.IPAddress != null)
		{
			if (type == "w")
			{
				wcurrIP = p.IPAddress(0);
			}
			if (type == "l")
			{
				lcurrIP = p.IPAddress(0);
			}
		}
		else
		{
			if (type == "w")
			{
				wcurrIP = "--";
			}
			if (type == "l")
			{
				lcurrIP = "--";
			}
		}
		if (p.MACAddress != null)
		{
			if (type == "w")
			{
				wcurrMAC = p.MACAddress(0);
			}
			if (type == "l")
			{
				lcurrMAC = p.MACAddress(0);
			}
		}
		else
		{
			if (type == "w")
			{
				wcurrMAC = "--";
			}
			if (type == "l")
			{
				lcurrMAC = "--";
			}
		}
	}
}

function getDomain()
{
	var proc;
	var query="SELECT * FROM Win32_ComputerSystem";
	proc = WMI.ExecQuery(query,"WQL",48);
	var e = new Enumerator (proc);
	for (;!e.atEnd();e.moveNext ())
	{
		var p = e.item ();
		if (p.Domain != null)
		{
			return p.Domain;
		}
		else
		{
			return "--";
		}
	}
}

//Getting the Device IPv4 DNS Address
function getDns()
{
	var ssid = wireless.ssid;
	if (ssid != "")
	{
		System.Shell.execute('http://' + wireless.primaryDNSAddress);
	}
	else
	{
		System.Shell.execute("::{20d04fe0-3aea-1069-a2d8-08002b30309d}\\::{21ec2020-3aea-1069-a2dd-08002b30309d}\\::{38A98528-6CBF-4CA9-8DC0-B1E1D10F7B1B}");
	}
}
