﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////

System.Gadget.onSettingsClosing = SettingsClosing;
var DisplayInGHz, DisplayDualCore, DisplayDualCPU, AutoUpdate, Homepage, altbcal;
var ShowCPU, ShowNet, ShowBat, ShowRAM, ShowDualCoreUsage, PlayBatBeep, HideBG;
var DisplayAMPM, DisplayAnimation,timeZoneIndex,ShowCal,DisplayKW,classicWiFi;
var physicalCPU;
var logicalCPU;
var gname = System.Gadget.name;
var tv = System.Gadget.version;
var gp = System.Gadget.path;
var Homepage = System.Gadget.document.parentWindow.Homepage;
var WMI = GetObject("winmgmts:\\\\.\\root\\CIMV2");
var interfaceCount;
var InterfaceArray = new Array();
InterfaceArray[0] = "none";
var interfaceCount=0;
var numofmods = System.Gadget.document.parentWindow.numofmods;
var numofaktmods = System.Gadget.Settings.read("numofaktmods");
var modpositions = new Array();
var newmodpositions = new Array();
var allmods = new Array();
var aktivemods = new Array();
var modpositionsstring;

var divColorPicker = false;
var divColorPicker_active_tab = false;
var cdivColorPicker_form_field = false;
var divColorPicker_active_input = false;

var settfirstrun;

function onLoad()
{
	settfirstrun = System.Gadget.Settings.read("settfirstrun");
	initSettings();
}

function onUnload()
{
	SettingsClosing;
}

function initSettings()
{
	InterfaceArray[0] = SomeText[1];
	wintfselect.options[0] = new Option(InterfaceArray[0], 0);
	intfselect.options[0] = new Option(InterfaceArray[0], 0);

	setTimeout(NICinitialize, 1000);
	clearTimeout(NICinitialize);

	fillDateVars();

	LoadSettings();

	checkupdate();
}

function NICinitialize()
{
	var proc;
	var query;
	query="SELECT * FROM Win32_NetworkAdapter WHERE AdapterType='Ethernet 802.3'";
	proc = WMI.ExecQuery(query,"WQL",48);
	var i = 1;
	var enumInstances = new Enumerator(proc);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == "Name")
			{
				InterfaceArray[i] = prop.Value;
				i++;
			}
		}
	}
	interfaceCount = i;

	if ((settfirstrun != "notset") && System.Gadget.Settings.read("wintfselect") && System.Gadget.Settings.read("intfselect"))
	{
		var chknic = checkNIC();
		if (chknic != true)
		{
			NICinitialize();
		}
		else
		{
			InterfaceArray[0] = SettText[5];
			wintfselect.options[wintfselect.length - 1] = null;
			intfselect.options[intfselect.length - 1] = null;
			fillInterfaceCombo();
			wintfselect.value = System.Gadget.Settings.read("wintfselect");
			intfselect.value = System.Gadget.Settings.read("intfselect");
		}
	}
	else
	{
		InterfaceArray[0] = SettText[5];
		wintfselect.options[wintfselect.length - 1] = null;
		intfselect.options[intfselect.length - 1] = null;
		fillInterfaceCombo();
		wintfselect.value = System.Gadget.Settings.read("wintfselect");
		intfselect.value = System.Gadget.Settings.read("intfselect");
	}
}

function checkNIC()
{
	if (InterfaceArray[System.Gadget.Settings.read("wintfselect")] != System.Gadget.Settings.read("wintfname"))
	{
		return false;
	}
	else if (InterfaceArray[System.Gadget.Settings.read("intfselect")] != System.Gadget.Settings.read("intfname"))
	{
		return false;
	}
	else
	{
		return true;
	}
}

function LoadSettings()
{
	clocktext1.innerText = SettText[0];
	clocktext2.innerText = SettText[13];
	checktext.innerText = SettText[1];
	bcaltext.innerText = SettText[2];
	ampmtext.innerText = SettText[23];
	animatetext.innerText = SettText[25];
	clocknametext.innerText = SettText[28];
	clockdnametext.innerText = SettText[28];
	currentDFtext.innerText = SettText[24];
	aupdatetext.innerText = UpdText[10];
	homepagetext.innerText = UpdText[11];
	mupdatebutton.value = UpdText[12];
	intfinfotext.innerText = SettText[6];
	wintftext.innerText = SettText[3];
	intftext.innerText = SettText[4];
	modinfotext.innerText = SettText[7];
	cpumodtext.innerText = SettText[8];
	netmodtext.innerText = SettText[9];
	batmodtext.innerText = SettText[10];
	batbeeptext.innerText = SettText[17];
	rammodtext.innerText = SettText[12];
	dualcoreusetext.innerText = SettText[14];
	uptmodtext.innerText = "Uptime";
	pwrmodtext.innerText = SettText[15];
	clkmodtext.innerText = SettText[22];
	calmodtext.innerText = wmtttext[18];
	wifistyletext.innerText = SettText[41];
	prvw_text.innerText = SettText[18];
	themetext.value = SettText[16];
	themeundobtn.value = SettText[20];
	themedefaultbtn.value = SettText[21];
	currTZtext.innerText = SettText[26];
	fonttext.innerText = SettText[29];
	transbacktext.innerText = SettText[30];
	firstwdaytext.innerText = SettText[32];
	kwtext.innerText = SettText[33];
	kwshowtext.innerText = SettText[36];

	gadgetcolourback = System.Gadget.Settings.read("gadgetcolourback");
	gadgetcolourlabel = System.Gadget.Settings.read("gadgetcolourlabel");
	gadgetcolournormal = System.Gadget.Settings.read("gadgetcolournormal");
	gadgetcolourwarn = System.Gadget.Settings.read("gadgetcolourwarn");
	gadgetcolourcritical = System.Gadget.Settings.read("gadgetcolourcritical");

	Content.style.backgroundColor = gadgetcolourback;
	Content.style.color = gadgetcolourlabel;

	aktualVersion.innerText = "You use " + gname + " Version " + tv;
	homepageinfo.innerText = "Help and information about this gadget you'll find at";
	homepagelinkinfo.innerHTML = "<a href=\"" + Homepage + "\">" + Homepage + "</a> (german and english)";

	DisplayDualCore=System.Gadget.Settings.read("dispdualcore");
	DisplayDualCPU=System.Gadget.Settings.read("dispdualcpu");
	physicalCPU=System.Gadget.Settings.read("physicalcpu");
	logicalCPU=System.Gadget.Settings.read("logicalcpu");

	uptmodheight = System.Gadget.Settings.read("uptmodheight");
	cpumodheight = System.Gadget.Settings.read("cpumodheight");
	rammodheight = System.Gadget.Settings.read("rammodheight");
	netmodheight = System.Gadget.Settings.read("netmodheight");
	batmodheight = System.Gadget.Settings.read("batmodheight");
	pwrmodheight = System.Gadget.Settings.read("pwrmodheight");
	clkmodheight = System.Gadget.Settings.read("clkmodheight");
	calmodheight = System.Gadget.Settings.read("calmodheight");
	gadgetheightcontainer = System.Gadget.Settings.read("gadgetheightcontainer");
	gadgetheightmods = System.Gadget.Settings.read("gadgetheightmods");
	gadgetheightsum = System.Gadget.Settings.read("gadgetheightsum");

	if (physicalCPU == "1")
	{
		clockbox1.disabled=true;
		clocktext1.style.color="grey";
	}
	else
	{
		clockbox1.disabled=false;
		clocktext1.style.color=gadgetcolourlabel;
	}

	if (logicalCPU == "1")
	{
		clockbox2.disabled=true;
		clocktext2.style.color="grey";
	}
	else
	{
		clockbox2.disabled=false;
		clocktext2.style.color=gadgetcolourlabel;
	}

	if (settfirstrun=="notset")
	{
		clockbox1.checked=false;
		clockbox2.checked=true;
	}
	else if (DisplayDualCPU==true && DisplayDualCore==false)
	{
		clockbox1.checked=true;
		clockbox2.checked=false;
	}
	else
	{
		clockbox1.checked=false;
		clockbox2.checked=true;
	}

	DisplayInGHz=System.Gadget.Settings.read("dispinghz");
	if(DisplayInGHz==0)
	{
		cpubox.checked=false;
	}
	else
	{
		cpubox.checked=true;
	}

	DisplayAMPM=System.Gadget.Settings.read("ampmbox");
	if(DisplayAMPM==false)
	{
		ampmbox.checked=false;
	}
	else
	{
		ampmbox.checked=true;
	}

	DisplayAnimation=System.Gadget.Settings.read("animatebox");
	if(DisplayAnimation==false)
	{
		animatebox.checked=false;
	}
	else
	{
		animatebox.checked=true;
	}

	altbcal=System.Gadget.Settings.read("altbcal");
	if(altbcal==0)
	{
		bcalcbox.checked=false;
	}
	else
	{
		bcalcbox.checked=true;
	}

	AutoUpdate=System.Gadget.Settings.read("autoupdate");
	if(AutoUpdate==0)
	{
		aupdatebox.checked=false;
	}
	else
	{
		aupdatebox.checked=true;
	}

	var x = 0;
	var x2 = 0;
	ShowCPU=System.Gadget.Settings.read("cpumodbox");
	allmods[x2] = "cpu";
	x2++;
	if (settfirstrun=="notset")
	{
		cpumodbox.checked=true;
		aktivemods[x] = "cpu";
		x++;
	}
	else if (ShowCPU==0)
	{
		cpumodbox.checked=false;
	}
	else
	{
		cpumodbox.checked=true;
		aktivemods[x] = "cpu";
		x++;
	}

	ShowNet=System.Gadget.Settings.read("netmodbox");
	allmods[x2] = "net";
	x2++;
	if (settfirstrun=="notset")
	{
		netmodbox.checked=true;
		aktivemods[x] = "net";
		x++;
	}
	else if(ShowNet==0)
	{
		netmodbox.checked=false;
	}
	else
	{
		netmodbox.checked=true;
		aktivemods[x] = "net";
		x++;
	}

	ShowBat=System.Gadget.Settings.read("batmodbox");
	allmods[x2] = "bat";
	x2++;
	if (settfirstrun=="notset")
	{
		batmodbox.checked=true;
		aktivemods[x] = "bat";
		x++;
	}
	else if(ShowBat==0)
	{
		batmodbox.checked=false;
	}
	else
	{
		batmodbox.checked=true;
		aktivemods[x] = "bat";
		x++;
	}

	PlayBatBeep=System.Gadget.Settings.read("batbeepbox");
	if (settfirstrun=="notset")
	{
		batbeepbox.checked=true;
	}
	else if(PlayBatBeep==0)
	{
		batbeepbox.checked=false;
	}
	else
	{
		batbeepbox.checked=true;
	}

	ShowUpt=System.Gadget.Settings.read("uptmodbox");
	allmods[x2] = "upt";
	x2++;
	if (settfirstrun=="notset")
	{
		uptmodbox.checked=false;
	}
	else if(ShowUpt==0)
	{
		uptmodbox.checked=false;
	}
	else
	{
		uptmodbox.checked=true;
		aktivemods[x] = "upt";
		x++;
	}

	ShowClk=System.Gadget.Settings.read("clkmodbox");
	allmods[x2] = "clk";
	x2++;
	if (settfirstrun=="notset")
	{
		clkmodbox.checked=true;
	}
	else if(ShowClk==0)
	{
		clkmodbox.checked=false;
	}
	else
	{
		clkmodbox.checked=true;
		aktivemods[x] = "clk";
		x++;
	}

	ShowCal=System.Gadget.Settings.read("calmodbox");
	allmods[x2] = "cal";
	x2++;
	if (settfirstrun=="notset")
	{
		calmodbox.checked=true;
	}
	else if(ShowCal==0)
	{
		calmodbox.checked=false;
	}
	else
	{
		calmodbox.checked=true;
		aktivemods[x] = "cal";
		x++;
	}

	ShowPwr=System.Gadget.Settings.read("pwrmodbox");
	allmods[x2] = "pwr";
	x2++;
	if (settfirstrun=="notset")
	{
		pwrmodbox.checked=false;
	}
	else if(ShowPwr==0)
	{
		pwrmodbox.checked=false;
	}
	else
	{
		pwrmodbox.checked=true;
		aktivemods[x] = "pwr";
		x++;
	}

	if (logicalCPU != "1")
	{
		dualcoreusebox.disabled=false;
		dualcoreusetext.style.color=gadgetcolourlabel;
		ShowDualCoreUsage=System.Gadget.Settings.read("dualcoreusebox");
		if (settfirstrun=="notset")
		{
			dualcoreusebox.checked=true;
		}
		else if(ShowDualCoreUsage==0)
		{
			dualcoreusebox.checked=false;
		}
		else
		{
			dualcoreusebox.checked=true;
		}
	}
	else
	{
		dualcoreusebox.checked=false;
		dualcoreusebox.disabled=true;
		dualcoreusetext.style.color="grey";
	}

	ShowRAM=System.Gadget.Settings.read("rammodbox");
	allmods[x2] = "ram";
	x2++;
	if (settfirstrun=="notset")
	{
		rammodbox.checked=false;
	}
	else if (ShowRAM==0)
	{
		rammodbox.checked=false;
		dualcoreusebox.disabled=true;
		dualcoreusetext.style.color="grey";
	}
	else
	{
		rammodbox.checked=true;
		dualcoreusebox.disabled=false;
		dualcoreusetext.style.color=gadgetcolourlabel;
		aktivemods[x] = "ram";
		x++;
	}

	HideBG=System.Gadget.Settings.read("transbackbox");
	if(HideBG==0)
	{
		transbackbox.checked=false;
	}
	else
	{
		transbackbox.checked=true;
	}

	classicWiFi=System.Gadget.Settings.read("classicWiFi");
	if(classicWiFi==0)
	{
		wifistylebox.checked=false;
	}
	else
	{
		wifistylebox.checked=true;
	}


	Homepage=System.Gadget.Settings.read("homepage");

	homepageurl.innerHTML="<a href=\"" + Homepage + "\">" + Homepage + "</a>";

	divSettings.style.display="block";
	divSettings2.style.display="none";
	divLayout.style.display="none";
	divUpdate.style.display="none";
	divInformation.style.display="none";

	inittheme();

	document.getElementsByName("themeinbck")[0].value = gadgetcolourback;
	document.getElementsByName("themeintxt1")[0].value = gadgetcolourlabel;
	document.getElementsByName("themeintxt2")[0].value = gadgetcolournormal;
	document.getElementsByName("themeintxt3")[0].value = gadgetcolourwarn;
	document.getElementsByName("themeintxt4")[0].value = gadgetcolourcritical;

	prev_text_div.style.backgroundColor = gadgetcolourback;
	prev_text_label.style.color = gadgetcolourlabel;
	prev_text_normal.style.color = gadgetcolournormal;
	prev_text_warn.style.color = gadgetcolourwarn;
	prev_text_critical.style.color = gadgetcolourcritical;

	divCP.style.display = "none";
	modsettings.style.display = "block";

	fillFontCombo();
	fontselect.value = System.Gadget.Settings.read("fontselect");

	prev_text_div.style.fontFamily = mniFonts[System.Gadget.Settings.read("fontselect")];

	currentDF = System.Gadget.Settings.read("currentDF");

	dateformatArray[0] = SettText[5];
	currentDFselect.options[0] = new Option(dateformatArray[0], 0);
	fillDFCombo();
	currentDFselect.value = currentDF;

	fillTZcombo();

	with (currTZselect)
	{
		value = getValidTimeZone(System.Gadget.Settings.read("timeZoneIndex"));
		title = options[selectedIndex].text;
	}

	clocknameinput.value = System.Gadget.Settings.read("clocknameinput");
	clockdnameinput.value = System.Gadget.Settings.read("clockdnameinput");

	fillfirstwdaycombo();
	firstwdayselect.value = System.Gadget.Settings.read("firstwdayselect");

	DisplayKW=System.Gadget.Settings.read("kwselect");
	fillKWcombo();
	kwselect.value = DisplayKW;

	DisplayKWshow=System.Gadget.Settings.read("kwshowselect");
	fillKWshowcombo();
	kwshowselect.value = DisplayKWshow;

	changefont();

	onchangeaction("cpumodbox");
	onchangeaction("rammodbox");
	onchangeaction("batmodbox");
	onchangeaction("netmodbox");
	onchangeaction("animatebox");
	onchangeaction("clockdname");
	onchangeaction("clkmodbox");
	onchangeaction("transbackbox");
	onchangeaction("kwselect");
}

function changefont()
{
	var nfz = 14;
	var i;
	for (i=0; i<mniFontsSuperBig.length;i++)
	{
		if(fontselect.value == mniFontsSuperBig[i])
		{
			nfz = nfz-4;
		}
	}
	for (i=0; i<mniFontsBig.length;i++)
	{
		if(fontselect.value == mniFontsBig[i])
		{
			nfz = nfz-2;
		}
	}
	for (i=0; i<mniFontsMiddle.length;i++)
	{
		if(fontselect.value == mniFontsMiddle[i])
		{
			nfz = nfz-1;
		}
	}
	for (i=0; i<mniFontsSmall.length;i++)
	{
		if(fontselect.value == mniFontsSmall[i])
		{
			nfz = nfz+1;
		}
	}

	prev_text_div.style.fontFamily = mniFonts[fontselect.value];
	prev_text_div.style.fontSize = nfz + "px";
}

function fillKWshowcombo()
{
	kwshowselect.options[0] = new Option(SettText[5], "0");
	kwshowselect.options[1] = new Option(SettText[37], "1");
	kwshowselect.options[2] = new Option(SettText[38], "2");
}

function fillKWcombo()
{
	kwselect.options[0] = new Option(SettText[34], "0"); // ISO
	kwselect.options[1] = new Option(SettText[35], "1"); // USA
	kwselect.options[2] = new Option(SettText[39], "2"); // JUL
	kwselect.options[3] = new Option(SettText[40], "3"); // ISL
}

function fillfirstwdaycombo()
{
	firstwdayselect.options[0] = new Option(clkDayslong[0], "0");
	firstwdayselect.options[1] = new Option(clkDayslong[1], "1");
}

function fillTZcombo()
{
	if (System.Gadget.Settings.read("timeZoneIndex") != "")
	{
		timeZoneIndex = System.Gadget.Settings.read("timeZoneIndex");
	}

	collTZones(true);

	currTZselect.options[0] = new Option(SettText[27], "-1");

	for (var i = 0; i < e.length; i++)
	{
		currTZselect.options[i+1] = new Option(e[i][eZone], e[i][eItem]);
		currTZselect.options[i+1].title = e[i][eZone];
	}
}

function toggledivColorPicker()
{
	var mset = document.getElementById('modsettings');
	var cset = document.getElementById('divCP');

	if(divCP.style.display=="none")
	{
		$(mset).hide("normal");
		$(cset).show("normal");

		themetext.value = SettText[19];
	}
	else
	{
		$(cset).hide("normal");
		$(mset).show("normal");

		themetext.value = SettText[16];
	}


}

function changeprvcolor(targetcolor,sourcecolor)
{
	if (targetcolor == "prev_text_div")
	{
		if (sourcecolor.value)
		{
			document.getElementById(targetcolor).style.backgroundColor = sourcecolor.value;
		}
		else
		{
			document.getElementById(targetcolor).style.backgroundColor = sourcecolor;
		}
	}
	else
	{
		if (sourcecolor.value)
		{
			document.getElementById(targetcolor).style.color = sourcecolor.value;
		}
		else
		{
			document.getElementById(targetcolor).style.color = sourcecolor;
		}
	}
}

function themeundo()
{
	divCP.style.display = "block";
	modsettings.style.display = "none";
	themetext.value = SettText[19];
	document.getElementsByName("themeinbck")[0].value = gadgetcolourback;
	document.getElementsByName("themeintxt1")[0].value = gadgetcolourlabel;
	document.getElementsByName("themeintxt2")[0].value = gadgetcolournormal;
	document.getElementsByName("themeintxt3")[0].value = gadgetcolourwarn;
	document.getElementsByName("themeintxt4")[0].value = gadgetcolourcritical;
	prev_text_div.style.backgroundColor = gadgetcolourback;
	prev_text_label.style.color = gadgetcolourlabel;
	prev_text_normal.style.color = gadgetcolournormal;
	prev_text_warn.style.color = gadgetcolourwarn;
	prev_text_critical.style.color = gadgetcolourcritical;

	buildthememods();
}

function themedefault()
{
	document.getElementsByName("themeinbck")[0].value = "black";
	document.getElementsByName("themeintxt1")[0].value = "white";
	document.getElementsByName("themeintxt2")[0].value = "turquoise";
	document.getElementsByName("themeintxt3")[0].value = "yellow";
	document.getElementsByName("themeintxt4")[0].value = "red";
	prev_text_div.style.backgroundColor = "black";
	prev_text_label.style.color = "white";
	prev_text_normal.style.color = "turquoise";
	prev_text_warn.style.color = "yellow";
	prev_text_critical.style.color = "red";

	buildthememods();
}

function nav(id)
{
	var sett1 = document.getElementById('divSettings');
	var sett2 = document.getElementById('divSettings2');
	var sett3 = document.getElementById('divLayout');
	var sett4 = document.getElementById('divUpdate');
	var sett5 = document.getElementById('divInformation');

	switch (id)
	{
		case 0:
			settbtn0.src = "/img/Settings/settBtnSettings_a.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(sett1).slideDown("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideUp("normal");
			break;
		case 1:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2_a.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(sett1).slideUp("normal");
			$(sett2).slideDown("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideUp("normal");
			break;
		case 2:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout_a.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(sett1).slideUp("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideDown("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideUp("normal");
			break;
		case 3:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate_a.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(sett1).slideUp("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideDown("normal");
			$(sett5).slideUp("normal");
			break;
		case 4:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo_a.png";
			$(sett1).slideUp("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideDown("normal");
			break;
	}
}

function fillInterfaceCombo()
{
	var i;
	for (i = 0;i < interfaceCount; i++)
	{
		wintfselect.options[wintfselect.length] = new Option(InterfaceArray[i], i);
		intfselect.options[intfselect.length] = new Option(InterfaceArray[i], i);
	}
}

function fillFontCombo()
{
	var i;
	for (i = 0;i < mniFonts.length; i++)
	{
		fontselect.options[fontselect.length] = new Option(mniFonts[i], i);
	}
}

function fillDFCombo()
{
	var Vortag  = ((Tag < 10) ? "0" : "");
	var Vormon  = ((Monat < 10) ? "0" : "");
	var Vorstd  = ((Stunden < 10) ? "0" : "");
	var Vormin  = ((Minuten < 10) ? "0" : "");
	var Vorsek  = ((Sekunden < 10) ? "0" : "");

	for (var i = 1;i < dateformatArray.length; i++)
	{
		var DFstring = "";
		var cDF = "";
		cDF = dateformatArray[i].split("");
		for (var x=0; x<cDF.length; x++)
		{
			if (cDF[x] === "W")
			{
				DFstring += clkDays[WoTag];
			}
			else if (cDF[x] === "w")
			{
				DFstring += clkDayslong[WoTag];
			}
			else if (cDF[x] === "D")
			{
				DFstring += Vortag + Tag;
			}
			else if (cDF[x] === "d")
			{
				DFstring += Tag;
			}
			else if (cDF[x] === "M")
			{
				DFstring += clkMonth[Monat];
			}
			else if (cDF[x] === "m")
			{
				DFstring += Monat;
			}
			else if (cDF[x] === "L")
			{
				DFstring += clkMonthlong[Monat];
			}
			else if (cDF[x] === "l")
			{
				DFstring += Vormon + Monat;
			}
			else if (cDF[x] === "Y")
			{
				DFstring += Jahr;
			}
			else if (cDF[x] === ".")
			{
				DFstring += ".";
			}
			else if (cDF[x] === " ")
			{
				DFstring += " ";
			}
			else if (cDF[x] === "/")
			{
				DFstring += "/";
			}
			else if (cDF[x] === "-")
			{
				DFstring += "-";
			}
			else if (cDF[x] === ",")
			{
				DFstring += ",";
			}
			else
			{
				DFstring += "";
			}
		}
		currentDFselect.options[currentDFselect.length] = new Option(DFstring, i);
	}
}

function onchangeaction(wert)
{
	if (wert == "cpumodbox")
	{
		if (cpumodbox.checked!=false)
		{
			cpubox.disabled=false;
			checktext.style.color=gadgetcolourlabel;
		}
		else
		{
			cpubox.disabled=true;
			checktext.style.color="gray";
		}
	}
	if (wert == "rammodbox")
	{
		if (rammodbox.checked!=false)
		{
			dualcoreusebox.disabled=false;
			dualcoreusetext.style.color=gadgetcolourlabel;
		}
		else
		{
			dualcoreusebox.disabled=true;
			dualcoreusetext.style.color="gray";
		}
	}
	if (wert == "batmodbox")
	{
		if (batmodbox.checked!=false)
		{
			bcalcbox.disabled=false;
			bcaltext.style.color=gadgetcolourlabel;
			batbeepbox.disabled=false;
			batbeeptext.style.color=gadgetcolourlabel;
		}
		else
		{
			bcalcbox.disabled=true;
			bcaltext.style.color="gray";
			batbeepbox.disabled=true;
			batbeeptext.style.color="gray";
		}
	}
	if (wert == "netmodbox")
	{
		if (netmodbox.checked!=false)
		{
			wifistylebox.disabled=false;
			wifistyletext.style.color=gadgetcolourlabel;
		}
		else
		{
			wifistylebox.disabled=true;
			wifistyletext.style.color="gray";
		}
	}
	if (wert == "animatebox")
	{
		var cset = document.getElementById('clocknametext');
		var mset = document.getElementById('clocknameinput');
		if (animatebox.checked==false)
		{
			$(cset).slideDown("normal");
			$(mset).slideDown("normal");
			clocknameinput.disabled=false;
			clocknametext.style.color=gadgetcolourlabel;
			clockdnametext.style.marginTop = -37;
		}
		else
		{
			$(cset).slideUp("normal");
			$(mset).slideUp("normal");
			clocknameinput.disabled=true;
			clocknametext.style.color="gray";
			clockdnametext.style.marginTop = 0;
		}
	}
	if (wert == "currentDF")
	{
		var cset = document.getElementById('clockdnametext');
		var mset = document.getElementById('clockdnameinput');
		if (currentDFselect.value==0)
		{
			$(cset).slideDown("normal");
			$(mset).slideDown("normal");
			clockdnameinput.disabled=false;
			clockdnametext.style.color=gadgetcolourlabel;
		}
		else
		{
			$(cset).slideUp("normal");
			$(mset).slideUp("normal");
			clockdnameinput.disabled=true;
			clockdnametext.style.color="gray";
		}
	}

	if (wert == "firstwdayselect")
	{
		if (firstwdayselect.value == 0) // sunday
		{
			if (kwselect.value == 0)
			{
				alert(SomeText[2]);
				firstwdayselect.value = 1;
			}
		}
		else if (firstwdayselect.value == 1) // monday
		{
			if (kwselect.value == 0)
			{
			}
		}
	}

	if (wert == "kwselect")
	{
		if (kwselect.value == 0) // ISO
		{
			firstwdayselect.value = 1;
			kwshowselect.disabled=false;
			kwshowtext.style.color=gadgetcolourlabel;
			firstwdayselect.disabled=true;
			firstwdayselect.style.color="gray";
		}
		else if (kwselect.value == 1) // USA
		{
			kwshowselect.disabled=false;
			kwshowtext.style.color=gadgetcolourlabel;
			firstwdayselect.disabled=false;
			firstwdayselect.style.color=gadgetcolourlabel;
		}
		else if (kwselect.value == 2) // Julian
		{
			kwshowselect.disabled=true;
			kwshowtext.style.color="gray";
			firstwdayselect.disabled=false;
			firstwdayselect.style.color=gadgetcolourlabel;
		}
		else if (kwselect.value == 3) // Islamic
		{
			firstwdayselect.value = 0;
			firstwdayselect.disabled=true;
			firstwdayselect.style.color="gray";
			kwshowselect.disabled=true;
			kwshowtext.style.color="gray";
		}
		else
		{
//			DisplayKW=System.Gadget.Settings.read("kwselect");
//			kwselect.options[0] = new Option(SettText[34], 0); // ISO
//			kwselect.options[1] = new Option(SettText[35], 1); // USA
//			kwselect.value = DisplayKW;
//			firstwdayselect.value = System.Gadget.Settings.read("firstwdayselect");
		}
	}
 	if (wert == "clkmodbox")
	{
		if (clkmodbox.checked!=false)
		{
			ampmbox.disabled=false;
			ampmtext.style.color=gadgetcolourlabel;
			animatebox.disabled=false;
			animatetext.style.color=gadgetcolourlabel;
			if (animatebox.checked==false)
			{
				clocknameinput.disabled=false;
				clocknametext.style.color=gadgetcolourlabel;
			}
			else
			{
				clocknameinput.disabled=true;
				clocknametext.style.color="gray";
			}
			currentDFselect.disabled=false;
			currentDFtext.style.color=gadgetcolourlabel;
			currTZselect.disabled=false;
			currTZtext.style.color=gadgetcolourlabel;
		}
		else
		{
			ampmbox.disabled=true;
			ampmtext.style.color="gray";
			animatebox.disabled=true;
			animatetext.style.color="gray";
			clocknameinput.disabled=true;
			clocknametext.style.color="gray";
			currentDFselect.disabled=true;
			currentDFtext.style.color="gray";
			currTZselect.disabled=true;
			currTZtext.style.color="gray";
		}
	}
	if (wert == "transbackbox")
	{
		var bset = document.getElementById('divback');
		if (transbackbox.checked!=true)
		{
			$(bset).slideDown("normal");
			divlabel.style.marginTop = "-15px";
			themeinback.disabled=false;
			themebuttonback.disabled=false;
		}
		else
		{
			$(bset).slideUp("normal");
			divlabel.style.marginTop = "0px";
			themeinback.disabled=true;
			themebuttonback.disabled=true;
		}
	}
}

function IEpreventOnChangeBug()
{
}

function change_prvw_mods(name)
{
	var tempid, tempname, newmodpositionsstring, newid, newname, newnumofaktmods;
	tempid = name + "modbox";

	if (document.getElementById(tempid).checked != false)
	{
		modpositionsstring += ",";
		modpositionsstring += numofaktmods + ",";
		modpositionsstring += name + ",";
		modpositionsstring += "p" + numofaktmods;

		modpositions[numofaktmods] = new Object();
		modpositions[numofaktmods][name] = "p" + numofaktmods;

		numofaktmods++;

		rebuildpositionstring(modpositionsstring);
		buildthememods();
	}
	else
	{
		newnumofaktmods = numofaktmods-1;
		if (newnumofaktmods < 1)
		{
			alert(SettText[11]);
			document.getElementById(tempid).checked = true;
			return;
		}

		newmodpositionsstring = "";
		modpositions = "";
		modpositions = new Array();
		var i2=0;
		for (var i = 0; i < modpositionsstring.length; i=i+3)
		{
			if (name != modpositionsstring[i+1])
			{
				newmodpositionsstring += i2 + ",";
				newmodpositionsstring += modpositionsstring[i+1] + ",";
				newmodpositionsstring += "p" + i2;
				if (i2 < (newnumofaktmods-1))
				{
					newmodpositionsstring += ",";
				}

				modpositions[i2] = new Object();
				modpositions[i2][modpositionsstring[i+1]] = "p" + i2;
				i2++;
			}
		}

		rebuildpositionstring(newmodpositionsstring);
		buildthememods();
	}
}

function sortmods(direction, id)
{
	var tempid, tempname, newtempid, newtempname, splitid, newmodpositionsstring, tid;
	newmodpositionsstring = "";
	splitid = id.split("");
	splitid[1] = parseInt(splitid[1]);

	if (direction == "up")
	{
		for (var i=0; i<numofaktmods; i++)
		{
			if (i == (splitid[1]-1))
			{
				tempid = "p" + i;
				newtempid = "p" + (i+1);
				tempname = document.getElementById(newtempid).name;
				newtempname = document.getElementById(tempid).name;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += tempname + ",";
				newmodpositionsstring += tempid;
			}
			else if (i == splitid[1])
			{
				newmodpositionsstring += i + ",";
				newmodpositionsstring += newtempname + ",";
				newmodpositionsstring += newtempid;
			}
			else if (i > splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}
			else if (i < splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}

			if (i < (numofaktmods-1))
			{
				newmodpositionsstring += ",";
			}
			tempid = "";
			tempname = "";
			tid = "";
		}
		newtempid = "";
		newtempname = "";
	}
	else if (direction == "down")
	{
		for (var i=0; i<numofaktmods; i++)
		{
			if (i == splitid[1])
			{
				tempid = "p" + i;
				newtempid = "p" + (i+1);
				tempname = document.getElementById(newtempid).name;
				newtempname = document.getElementById(tempid).name;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += tempname + ",";
				newmodpositionsstring += tempid;
			}
			else if (i == (splitid[1]+1))
			{
				newmodpositionsstring += i + ",";
				newmodpositionsstring += newtempname + ",";
				newmodpositionsstring += newtempid;
			}
			else if (i > splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}
			else if (i < splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}

			if (i < (numofaktmods-1))
			{
				newmodpositionsstring += ",";
			}
			tempid = "";
			tempname = "";
			tid = "";
		}
		newtempid = "";
		newtempname = "";
	}

	rebuildpositionstring(newmodpositionsstring);
	buildthememods();
}

function inittheme()
{
	modpositionsstring = "";
	modpositionsstring = System.Gadget.Settings.read("modpositions").split(",");
	var i2=0;
	for (var i = 0; i < modpositionsstring.length; i=i+3)
	{
		modpositions[i2] = new Object();
		modpositions[i2][modpositionsstring[i+1]] = modpositionsstring[i+2];
		i2++;
	}
	numofaktmods = modpositions.length;
	buildthememods();
}

function rebuildpositionstring(newmodpositionsstring)
{
	modpositionsstring = "";
	modpositionsstring = newmodpositionsstring.split(",");
	modpositions = "";
	modpositions = new Array();
	var i2=0;
	for (var i = 0; i < modpositionsstring.length; i=i+3)
	{
		modpositions[i2] = new Object();
		modpositions[i2][modpositionsstring[i+1]] = modpositionsstring[i+2];
		i2++;
	}
	numofaktmods = modpositions.length;
}

function buildthememods()
{
	modseq.innerHTML = "";

	var tempsrc, tempsrcu, tempsrcd, tempsrcui, tempsrcdi;
	var tempid, tempname, temptable, prvpath, prvcolor;

	if(document.getElementsByName("themeinbck")[0].value)
	{
		prvcolor = document.getElementsByName("themeinbck")[0].value;
	}
	else if (gadgetcolourback)
	{
		prvcolor = gadgetcolourback;
	}
	else
	{
		prvcolor = "black";
	}
	document.getElementsByName("themeinbck")[0].value = prvcolor;

	prvpath = "/img/Settings/preview/";
	tempsrcu = prvpath + "prvw_up_akt.png";
	tempsrcd = prvpath + "prvw_down_akt.png";
	tempsrcui = prvpath + "prvw_up_inakt.png";
	tempsrcdi = prvpath + "prvw_down_inakt.png";

	temptable = "<table cellpadding=\"0\" cellspacing=\"2\" border=\"0\">";
	temptable += "<tr><td valign=\"bottom\" bgcolor=\"" + prvcolor + "\"><img width=\"100\" id=\"prvwhead\" src=\"" + prvpath + "/preview_head.png\"></td>";
	temptable += "<td></td>";
	temptable += "</tr>";
	temptable += "";
	for (var i2=0; i2<numofaktmods; i2++)
	{
		tempid = "p" + i2;
		for (var i = 0; i < numofaktmods; i++)
		{
			for (var pos in modpositions[i])
			{
				if (modpositions[i][pos] == tempid)
				{
					tempname = pos;
					tempsrc = prvpath + "/preview_" + tempname + ".png";

					temptable += "<tr><td rowspan=\"2\" bgcolor=\"" + prvcolor + "\"><img width=\"100\" id=\"" + tempid + "\" name=\"" + tempname + "\" src=\"" + tempsrc + "\"></td>";
					if (i2 == 0)
					{
						temptable += "<td valign=\"bottom\" width=\"20\"><img id=\"" + tempid + "u\" src=\"" + tempsrcui + "\"></td>";
					}
					else
					{
						temptable += "<td valign=\"bottom\" width=\"20\"><img id=\"" + tempid + "u\" src=\"" + tempsrcu + "\" onclick=\"sortmods('up', '" + tempid + "')\" style=\"cursor:pointer;\"></td>";
					}
					temptable += "</tr>";
					if (i2 == (numofaktmods-1))
					{
						temptable += "<tr><td valign=\"top\" width=\"20\"><img id=\"" + tempid + "d\" src=\"" + tempsrcdi + "\"></td>";
					}
					else
					{
						temptable += "<tr><td valign=\"top\" width=\"20\"><img id=\"" + tempid + "d\" src=\"" + tempsrcd + "\" onclick=\"sortmods('down', '" + tempid + "')\" style=\"cursor:pointer;\"></td>";
					}
					temptable += "</tr>";
				}
			}
		}
	}
	temptable += "<tr><td valign=\"top\" bgcolor=\"" + prvcolor + "\"><img width=\"100\" id=\"prvwfoot\" src=\"" + prvpath + "/preview_foot.png\"></td>";
	temptable += "<td></td>";
	temptable += "</tr>";
	temptable += "</table>";
	modseq.innerHTML = temptable;
}

function SettingsClosing(event)
{
	// Save the settings if the user clicked OK.
	if (event.closeAction == event.Action.commit)
	{
		if (!calmodbox.checked && !clkmodbox.checked && !uptmodbox.checked && !cpumodbox.checked && !rammodbox.checked && !netmodbox.checked && !batmodbox.checked && !pwrmodbox.checked)
		{
			alert(SettText[11]);
			return;
		}
		else
		{
			gadgetheightsum = gadgetheightcontainer;
			if (clkmodbox.checked!=false)
			{
				gadgetheightsum += clkmodheight;
			}
			if (calmodbox.checked!=false)
			{
				gadgetheightsum += calmodheight;
			}
			if (uptmodbox.checked!=false)
			{
				gadgetheightsum += uptmodheight;
			}
			if (cpumodbox.checked!=false)
			{
				gadgetheightsum += cpumodheight;
			}
			if (netmodbox.checked!=false)
			{
				gadgetheightsum += netmodheight;
			}
			if (batmodbox.checked!=false)
			{
				gadgetheightsum += batmodheight;
			}
			if (rammodbox.checked!=false)
			{
				gadgetheightsum += rammodheight;
			}
			if (pwrmodbox.checked!=false)
			{
				gadgetheightsum += pwrmodheight;
			}
			System.Gadget.Settings.write("gadgetheightsum", gadgetheightsum);

			System.Gadget.Settings.write("clkmodbox", clkmodbox.checked);
			System.Gadget.Settings.write("calmodbox", calmodbox.checked);
			System.Gadget.Settings.write("uptmodbox", uptmodbox.checked);
			System.Gadget.Settings.write("cpumodbox", cpumodbox.checked);
			System.Gadget.Settings.write("netmodbox", netmodbox.checked);
			System.Gadget.Settings.write("batmodbox", batmodbox.checked);
			System.Gadget.Settings.write("rammodbox", rammodbox.checked);
			System.Gadget.Settings.write("pwrmodbox", pwrmodbox.checked);

			if (clockbox1.checked!=false)
			{
				System.Gadget.Settings.write("dispdualcpu", "True");
			}
			else
			{
				System.Gadget.Settings.write("dispdualcpu", "False");
			}
			if (clockbox2.checked!=false)
			{
				System.Gadget.Settings.write("dispdualcore", "True");
			}
			else
			{
				System.Gadget.Settings.write("dispdualcore", "False");
			}
			System.Gadget.Settings.write("dispinghz", cpubox.checked);
			System.Gadget.Settings.write("autoupdate", aupdatebox.checked);
			System.Gadget.Settings.write("batbeepbox", batbeepbox.checked);
			System.Gadget.Settings.write("dualcoreusebox", dualcoreusebox.checked);
			System.Gadget.Settings.write("ampmbox", ampmbox.checked);
			System.Gadget.Settings.write("animatebox", animatebox.checked);
			System.Gadget.Settings.write("altbcal", bcalcbox.checked);
			System.Gadget.Settings.write("transbackbox", transbackbox.checked);
			System.Gadget.Settings.write("classicWiFi", wifistylebox.checked);

			System.Gadget.Settings.write("wintfselect", wintfselect.value);
			System.Gadget.Settings.write("wintfname", InterfaceArray[wintfselect.value]);

			System.Gadget.Settings.write("intfselect", intfselect.value);
			System.Gadget.Settings.write("intfname", InterfaceArray[intfselect.value]);

			System.Gadget.Settings.write("InterfaceArray", InterfaceArray)

			System.Gadget.Settings.write("fontselect", fontselect.value);

			System.Gadget.Settings.write("currentDF",currentDFselect.value);
			System.Gadget.Settings.write("timeZoneIndex",currTZselect.value);
			System.Gadget.Settings.write("clocknameinput", clocknameinput.value);
			System.Gadget.Settings.write("clockdnameinput", clockdnameinput.value);
			System.Gadget.Settings.write("firstwdayselect",firstwdayselect.value);
			System.Gadget.Settings.write("kwselect", kwselect.value);
			System.Gadget.Settings.write("kwshowselect", kwshowselect.value);

			System.Gadget.Settings.write("gadgetcolourback", document.getElementsByName("themeinbck")[0].value);
			System.Gadget.Settings.write("gadgetcolourlabel", document.getElementsByName("themeintxt1")[0].value);
			System.Gadget.Settings.write("gadgetcolournormal", document.getElementsByName("themeintxt2")[0].value);
			System.Gadget.Settings.write("gadgetcolourwarn", document.getElementsByName("themeintxt3")[0].value);
			System.Gadget.Settings.write("gadgetcolourcritical", document.getElementsByName("themeintxt4")[0].value);

			System.Gadget.Settings.write("numofaktmods",numofaktmods);
			System.Gadget.Settings.write("modpositions",modpositionsstring);

			System.Gadget.Settings.write("settfirstrun","set");
		}
	}
	// Allow the Settings dialog to close.
	event.cancel = false;
}


