﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////


var SysEnv = System.Environment;
var oSYS;

var firstrun = 1;

var DevName = new Array();
DevName[0] = "Manufacturer";
DevName[1] = "Model";
DevName[2] = "SystemType";
DevName[3] = "DNSHostName";
DevName[4] = "PartOfDomain";
DevName[5] = "Domain";
DevName[6] = "DomainRole";
DevName[7] = "Workgroup";
DevName[8] = "CurrentTimeZone";
DevName[9] = "DaylightInEffect";
DevName[10]= "EnableDaylightSavingsTime";
DevName[11]= "BootupState";
DevName[12]= "ThermalState";
DevName[13]= "AutomaticManagedPagefile";
DevName[14]= "AutomaticResetBootOption";
DevName[15]= "AutomaticResetCapability";
DevName[16]= "BootROMSupported";
DevName[17]= "InfraredSupported";
DevName[18]= "KeyboardPasswordStatus";
DevName[19]= "WakeUpType";

var TBody1 = new Array();

function Init()
{
	sysCollect.innerText = SomeText[1];
	sysCollect.style.display="block";

	Content.style.backgroundColor = System.Gadget.Settings.read("gadgetcolourback");
	Content.style.color = System.Gadget.Settings.read("gadgetcolourlabel");
	headimg.src = "/img/Flyout/syshead.png";
    setInterval(onTimer,980);
}

function onTimer()
{
	if (firstrun == "1")
	{
	    firstrun = "0";
	}
	else
	{
		GetSysInfo();
	    firstrun = "0";
	}
}

function GetSysInfo()
{
	if (firstrun == 0)
	{
		clearTable("sTable");
	}

	var CompName = SysEnv.machineName;
	AddTableRow("sTable", "ComputerName", CompName);

	oSYS = GetObject("winmgmts:\\\\.\\root\\CIMV2");
	var query="SELECT * FROM Win32_ComputerSystem";
	var proc = oSYS.ExecQuery(query,"WQL",48);
	ShowDevices(proc, "TBody1");

	for (var i=0; i < DevName.length; i++)
	{
		if (DevName[i] == "DomainRole")
		{
			AddTableRow("sTable", DevName[i], DomainRole[TBody1[i]]);
		}
		else if (DevName[i] == "ThermalState")
		{
			AddTableRow("sTable", DevName[i], ThermalState[TBody1[i]]);
		}
		else if (DevName[i] == "KeyboardPasswordStatus")
		{
			AddTableRow("sTable", DevName[i], KeyboardPasswordStatus[TBody1[i]]);
		}
		else if (DevName[i] == "WakeUpType")
		{
			AddTableRow("sTable", DevName[i], WakeUpType[TBody1[i]]);
		}
		else if (DevName[i] == "CurrentTimeZone")
		{
			var ctz = (TBody1[i] / 60);
			if (ctz > 0)
			{
				 ctz = "GMT +" + ctz;
			}
			AddTableRow("sTable", DevName[i], ctz);
		}
		else
		{
			AddTableRow("sTable", DevName[i], TBody1[i]);
		}
	}

	sfoot.innerText = SomeText[0];
	sysCollect.style.display="none";
}

function ShowDevices(instances, className)
{
	var enumInstances = new Enumerator(instances);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			for (var i=0; i<DevName.length; i++)
			{
				if (prop.Name == DevName[i])
				{
					var pval="";
					pval = prop.Value;

					if (className == "TBody1")
					{
						TBody1[i] = pval;
					}
				}
			}
		}
	}
}



function AddTableRow(tab, content, content2)
{
	var TabElem = document.getElementById(tab);
	var NewRow = document.createElement("tr");
	if(NewRow.style.display)
	{
		NewRow.style.display="table-row";
	}

	var NewRowContent = document.createElement("td");
	if(NewRowContent.style.display)
	{
		NewRowContent.style.display="table-cell";
//		NewRowContent.style.width=100;
		NewRowContent.style.whiteSpace="normal";
	}
	var NewRowContent_Text = document.createTextNode(content);
	NewRowContent.appendChild(NewRowContent_Text);

	var NewRowContent2 = document.createElement("td");
	if(NewRowContent2.style.display)
	{
		NewRowContent2.style.display="table-cell";
//		NewRowContent2.style.width=180;
		NewRowContent2.style.whiteSpace="normal";
	}
	var NewRowContent2_Text = document.createTextNode(content2);
	NewRowContent2.appendChild(NewRowContent2_Text);

	NewRow.appendChild(NewRowContent);
	NewRow.appendChild(NewRowContent2);
	TabElem.getElementsByTagName("tbody")[0].appendChild(NewRow);

//	if(document.getElementById(tab).outerHTML)document.getElementById(tab).outerHTML=document.getElementById(tab).outerHTML;
}

function clearTable(wert)
{
	if (wert == "sTable")
	{
		var rowsnum = sTable.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			sTable.deleteRow(i);
		}
	}
}


